//
//  HttpRequest.m
//  大麦网
//
//  Created by qf on 15-4-1.
//  Copyright (c) 2015年 lirunmin. All rights reserved.
//

#import "HttpRequest.h"

#pragma clang diagnostic ignored "-Warc-performSelector-leaks"

@interface HttpRequest()<NSURLConnectionDataDelegate>
{
    NSURLConnection *_connection;
    NSString *_url;
    id _target;
    SEL _action;
}

@end

@implementation HttpRequest

-(void)requestWithUrl:(NSString *)url target:(id)target action:(SEL)action
{
    _url = url;
    _target = target;
    _action = action;
    
    
    _data = [[NSMutableData alloc] init];
    //发起URL请求
    _connection = [[NSURLConnection alloc] initWithRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:url]] delegate:self startImmediately:YES];
    
}

-(void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    [_data appendData:data];
}

-(void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    //下载完成了，执行保存的方法
    if(_target && [_target respondsToSelector:_action])
    {
        [_target performSelector:_action withObject:self];
    }
}
@end
