//
//  ViewController.m
//  ManzuoProject
//
//  Created by qf on 15-4-2.
//  Copyright (c) 2015年 lirunmin. All rights reserved.
//

#import "ViewController.h"

#import "HttpRequest.h"

#import "GDataXMLNode.h"

#import "PromotionModel.h"

#import "UIScrollView+AH3DPullRefresh.h"

#import "PromotionCell.h"

#import "UIImageView+WebCache.h"

#import "ScrollViewModel.h"

#define MAIN_SHOP_URL @"http://mps.manzuo.com/mps/cate?sid=(null)&id=0&cc=%@&pt=%@&ffst=%d&mnt=%d&st=-1&hs=1"

#define MAIN_ADS_URL @"http://mp.manzuo.com/china/%@/home_2.xml"

@interface ViewController ()<UITableViewDataSource,UITableViewDelegate>
{
    HttpRequest *_request1;
    HttpRequest *_request2;
    NSString *_city;
    NSString *_category;
    int _offset;
    int _pageSize;
    
    NSMutableArray *_dataArray;
    
    UITableView *_tableView;
    UIScrollView *_scrollView;
    NSMutableArray *_array;
}
@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    _city = @"beijing";
    _category = @"all";
    _offset = 1;
    _pageSize = 10;
    
    _array=[[NSMutableArray alloc] init];
    _dataArray = [[NSMutableArray alloc] init];
    [self createUI];
    [self startDownloadData];
    
    [self createTableView];
    
    [self addPullRefreshAndPullLoadMore];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(createScrollView) name:@"setScrollView" object:nil];
    
    NSLog(@"icon=%d",_array.count);
}

-(void)createScrollView
{
    UIView *view=[[UIView alloc] initWithFrame:CGRectMake(0, 0, 320, 120)];
    [self.view addSubview:view];
    _scrollView=[[UIScrollView alloc] initWithFrame:CGRectMake(0, 0, 320, 120)];
    _scrollView.contentSize=CGSizeMake(320*3, 0);
    _scrollView.bounces = NO;
    _scrollView.delegate = self;
    _scrollView.showsHorizontalScrollIndicator = NO;
    _scrollView.showsVerticalScrollIndicator = NO;
    _scrollView.pagingEnabled = YES;
    [view addSubview:_scrollView];
    
    for(int i=0;i<_array.count;i++)
    {
        UIImageView *imageView=[[UIImageView alloc] initWithFrame:CGRectMake(320*i, 0, 320, 120)];
        ScrollViewModel *model=[_array objectAtIndex:i];
        [imageView setImageWithURL:[NSURL URLWithString:model.icon]];
        NSLog(@"=========icon=%@",model.icon);

        [_scrollView addSubview:imageView];
    }
        //[[NSNotificationCenter defaultCenter] postNotificationName:@"setScrollView" object:nil userInfo:nil];

}

-(void)createUI
{
    //设置导航条标题
    UIImageView *imageView=[[UIImageView alloc] init];
    imageView.image=[UIImage imageNamed:@"title_logo.png"];
    imageView.frame=CGRectMake(120, 10, 80, 44);
    self.navigationItem.titleView=imageView;
    
    //设置导航栏左按钮
    UIButton *btn1=[[UIButton alloc] init];
    btn1.frame=CGRectMake(0, 0, 35, 40);
    [btn1 setImage:[UIImage imageNamed:@"shake_btn.png"] forState:UIControlStateNormal];
    UIBarButtonItem *item1=[[UIBarButtonItem alloc] initWithCustomView:btn1];
    self.navigationItem.leftBarButtonItem=item1;
    
    //设置导航栏右按钮
    UIButton *btn2=[UIButton buttonWithType:UIButtonTypeCustom];
    btn2.frame=CGRectMake(0, 0, 70, 40);
    [btn2 setTitle:@"北京" forState:UIControlStateNormal];
    [btn2 setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];

    [btn2 setImage:[UIImage imageNamed:@"ico_drop.png"] forState:UIControlStateNormal];
    btn2.titleEdgeInsets=UIEdgeInsetsMake(0, -40, 0, 0);
    btn2.imageEdgeInsets=UIEdgeInsetsMake(0, 40, 0, 0);
    UIBarButtonItem *item2=[[UIBarButtonItem alloc] initWithCustomView:btn2];
    self.navigationItem.rightBarButtonItem=item2;
    
    //全部按钮
    UIButton *_allButton=[UIButton buttonWithType:UIButtonTypeCustom];
    _allButton.frame=CGRectMake(0, 120, 160, 40);
    _allButton.backgroundColor=[UIColor whiteColor];
    [_allButton setBackgroundImage:[UIImage imageNamed:@"leftDrop_bg_selected.png"] forState:UIControlStateSelected];
    [_allButton setBackgroundImage:[UIImage imageNamed:@"leftDrop_bg_press.png"] forState:UIControlStateHighlighted];
    [_allButton setTitle:@"全部" forState:UIControlStateNormal];
    [_allButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    [_allButton setBackgroundImage:[UIImage imageNamed:@"leftDrop_bg.png"] forState:UIControlStateNormal];
    [_allButton setBackgroundImage:[UIImage imageNamed:@"leftDrop_bg_disable.png"] forState:UIControlStateDisabled];
    [_allButton setImage:[UIImage imageNamed:@"all.png"] forState:UIControlStateNormal];
    [self.view addSubview:_allButton];
    
    
    //排行按钮
    UIButton *_sortButton=[UIButton buttonWithType:UIButtonTypeCustom];
    _sortButton.frame=CGRectMake(160, 120, 160, 40);
    _sortButton.backgroundColor=[UIColor whiteColor];
    [_sortButton setBackgroundImage:[UIImage imageNamed:@"rightDrop_bg_selected.png"] forState:UIControlStateSelected];
    [_sortButton setBackgroundImage:[UIImage imageNamed:@"rightDrop_bg_press.png"] forState:UIControlStateHighlighted];
    [_sortButton setTitle:@"人气最高" forState:UIControlStateNormal];
    [_sortButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    [_sortButton setBackgroundImage:[UIImage imageNamed:@"rightDrop_bg_disable.png"] forState:UIControlStateDisabled];
    [_sortButton setBackgroundImage:[UIImage imageNamed:@"rightDrop_bg.png"] forState:UIControlStateNormal];
    [_sortButton setImage:[UIImage imageNamed:@"sort.png"] forState:UIControlStateNormal];
    [self.view addSubview:_sortButton];
    
}

#pragma mark - 下拉刷新和上拉加载更多
-(void)addPullRefreshAndPullLoadMore
{
    [_tableView setPullToRefreshHandler:^{
        //从第一行数据开始下载
        _offset = 1;
        [self startDownloadData];
    }];
    
    [_tableView setPullToLoadMoreHandler:^{
        _offset += _pageSize;
        [self startDownloadData];
    }];
}

#pragma mark - createTableView
-(void)createTableView
{
    _tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 160, 320, 480) style:UITableViewStylePlain];
    _tableView.dataSource = self;
    _tableView.delegate = self;
    [self.view addSubview:_tableView];
    
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return _dataArray.count;
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *identifier = @"cell";
    
    PromotionCell *cell = [tableView dequeueReusableCellWithIdentifier:identifier];
    if(cell == nil)
    {
        cell = [[[NSBundle mainBundle] loadNibNamed:@"PromotionCell" owner:self options:nil] firstObject];
    }
    
    PromotionModel *model = [_dataArray objectAtIndex:indexPath.row];
    
    cell.nameLabel.text= model.name;
    cell.priceLabel.text=model.price;
    cell.priceoffLabel.text=model.priceoff;
    cell.currentdealcountLabel.text=model.currentdealcount;
    cell.districtLabel.text=model.district;
  
    [cell.wsdimgImageView setImageWithURL:[NSURL URLWithString:model.wsdimg]];


    
    return cell;
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 120;
}

-(void)startDownloadData
{
    NSString *urlString = [NSString stringWithFormat:MAIN_SHOP_URL,_city,_category,_offset,_pageSize];
    NSString *urlString1=[NSString stringWithFormat:MAIN_ADS_URL,_city];
    
    _request1 = [[HttpRequest alloc] init];
    _request2 = [[HttpRequest alloc] init];
    [_request1 requestWithUrl:urlString target:self action:@selector(dealDownloadFinish:)];
    [_request2 requestWithUrl:urlString1 target:self action:@selector(scrollViewDownload:)];
}

-(void)scrollViewDownload:(HttpRequest *)request
{
    GDataXMLDocument *doc=[[GDataXMLDocument alloc] initWithData:request.data options:0 error:nil];
    NSArray *alist=[doc nodesForXPath:@"//activity" error:nil];
    for(GDataXMLElement *p in alist)
    {
        ScrollViewModel *model=[[ScrollViewModel alloc] init];
        model.icon=[[[p elementsForName:@"img"] firstObject] stringValue];
        NSLog(@"aaa=%@",model.icon);
        [_array addObject:model];
    }
    NSLog(@"icon=%d",_array.count);

    [[NSNotificationCenter defaultCenter] postNotificationName:@"setScrollView" object:nil];
}

-(void)dealDownloadFinish:(HttpRequest *)request
{
    GDataXMLDocument *doc = [[GDataXMLDocument alloc] initWithData:request.data options:0 error:nil];
    NSArray *list = [doc nodesForXPath:@"//promotion" error:nil];
    
    //如果_offset = 1,刷新
    if(_offset == 1)
    {
        [_dataArray removeAllObjects];
    }
    
    for(GDataXMLElement *promotion in list)
    {
        PromotionModel *model = [[PromotionModel alloc] init];
        model.id = [[[promotion elementsForName:@"id"] firstObject] stringValue];
        model.name = [[[promotion elementsForName:@"name"] firstObject] stringValue];
        model.price=[[[promotion elementsForName:@"price"] firstObject] stringValue];
        model.priceoff=[[[promotion elementsForName:@"priceoff"] firstObject] stringValue];
        model.currentdealcount=[[[promotion elementsForName:@"currentdealcount"] firstObject] stringValue];
        model.district=[[[promotion elementsForName:@"district"] firstObject] stringValue];
        model.wsdimg=[[[promotion elementsForName:@"wsdimg"] firstObject] stringValue];
        
        [_dataArray addObject:model];
    }
    
    //结束刷新
    [_tableView refreshFinished];
    
    [_tableView loadMoreFinished];
    
    [_tableView reloadData];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
